/*
************************************************************
* Dateiname: lehmer16.cpp Datum: 01.11. 2003 Autor: Pitri  *
************************************************************
*/

/* Includes */
/* --------*/
#include "stdlib.h"
#include "stdio.h"
#include "math.h"

#define LONG 32
#define BIT_PER_LONG 16
#define MANCO_TO_LONG32 LONG-BIT_PER_LONG
#define MAX_LONG_WERT 65535
#define NY_X 65536
#define BIGEST_LONG_BIT 32768


int main
/******/
/*
getestet bis 4253 is prime
Lucas Lehmer Test
Dieses Programm ist eine wahrscheinlich unbefriedigende Lsung vom Original. Das heisst ich habe meine 
Idee umgesetzt und ein Programm geschrieben zur Basis 2y32. Eben genau so wie ich mir die erweitertete
schnelle Fourier Transformation ausgedacht habe. Das funktioniert sogar aber es gibt da ein Problem...
nmlich sind die zur Verfgung gestellten Datentypen nicht in der Lage Zahlen von 3y32 im Quadrat als 
double genau darzustellen. Ich brauchte 20 Stellen. Double ist nur 15 Stellen genau. Das ist wirklich
sehr rgerlich. Bevor ich mir Gedanken mache wie ich selbst einen eigenen Doubletyp programmieren kann
versuche ich nun mal das bestehende Programm von der 32bit Idee auc 16bit zu reduzieren. Das wird natrlich
mindestens 10mal langsamer...
Folgendes Programm ist nun also die 16bit Version.

Die massivsten aenderungen waren bei der Funktion fast_modulo_2y16. Ansonsten waren nur sehr einfache 
aenderungen ntig.
*/
(
  int argc,
  char *argv[]
)
{
  // Funktionen
  int  get_n(int u2_len_long);
  void get_einheitswurzel(int n,double*wr,double*wi);
  void get_einheitswurzel2(int n,double*wr,double*wi);
  void get_fast_dft_vektor_2y16(int a,unsigned long*buffer,unsigned long*numerals,int len_numerals,double*wr,double*wi,double*dft_r,double*dft_i);
  void get_fast_inverse_dft_vektor(int n,double *buffer,double *wr,double *wi,double *dft_r,double *dft_i,double *res_polynom);
  void mul_dft(int n,double*dft_r1,double*dft_i1,double*dft_r2,double*dft_i2,double*res_dft_r,double*res_dft_i);
  void inverse_dft_vektor(int n,double*wr,double*wi,double*dft_r,double*dft_i,double*inf_dft_r,double*inf_dft_i,double*res_polynom);
  void decode_polynom_2y16(double*polynom,int polynom_len,unsigned long*res_2y16,int *res_2y16_len);
  void fast_modulo_2y16(unsigned long*u1,unsigned long*u2,int*u1_len_long,int*u2_len_long,int mersenne_number);
  void str_minus_zwei(unsigned long*u2,int*u2_anz_long);

  void type_long_array(unsigned long*a1,int len_a1);
  void type_long_array_dez(unsigned long*a1,int len_a1);

  // Variablen
  int i1;
  int n1;
  int u2_len_long;
  int u1_len_long;
  int me_byte;
  int me_number;
  unsigned long *buffer;
  unsigned long *u2;
  unsigned long *u1;
  double *buffer2;
  double *wr;
  double *wi;
  double *dft_r1;
  double *dft_i1;
  double *res_dft_r;
  double *res_dft_i;
  double *inf_dft_r;
  double *inf_dft_i;
  double *res_polynom;

  // Initialisierungen
  printf("Primzahl n von der zu pruefenden Mersenneschen Zahl eingeben:");
  scanf("%d",&me_number);

//me_byte=me_number/LONG+1;
me_byte=(me_number/BIT_PER_LONG+1)*2*4;

  // Speicher allozieren
  buffer2=(double*)calloc(4*me_byte,sizeof(double));
  if(buffer2==NULL)
  {
    printf("Fehler beim Speicherallozieren, buffer2\n");
  }
  else
  {
    printf("buffer2 Speicher alloziert\n");
  }

  // Speicher allozieren
  buffer=(unsigned long*)calloc(4*me_byte,sizeof(unsigned long)); //4 fach weil bei fft 2erPotenz.....
  if(buffer==NULL)
  {
    printf("Fehler beim Speicherallozieren, buffer\n");
  }
  else
  {
    printf("buffer Speicher alloziert\n");
  }

  // Speicher allozieren
  u2=(unsigned long*)calloc(4*me_byte,sizeof(unsigned long)); //4 fach weil bei fft 2erPotenz.....
  if(u2==NULL)
  {
    printf("Fehler beim Speicherallozieren, u2\n");
  }
  else
  {
    printf("u2 Speicher alloziert\n");
  }

  // Speicher allozieren
  u1=(unsigned long*)calloc(me_byte,(sizeof(unsigned long))/2+1);
  if(u1==NULL)
  {
    printf("Fehler beim Speicherallozieren, u1\n");
  }
  else
  {
    printf("u1 Speicher alloziert\n");
  }

  // Speicher allozieren
  wr=(double*)calloc(2*me_byte,sizeof(double));
  if(wr==NULL)
  {
    printf("Fehler beim Speicherallozieren, wr\n");
  }
  else
  {
    printf("wr Speicher alloziert\n");
  }

  // Speicher allozieren
  wi=(double*)calloc(2*me_byte,sizeof(double));
  if(wi==NULL)
  {
    printf("Fehler beim Speicherallozieren, wi\n");
  }
  else
  {
    printf("wi Speicher alloziert\n");
  }

  // Speicher allozieren
  dft_r1=(double*)calloc(4*me_byte,sizeof(double)); //4 fach weil bei fft 2erPotenz.....
  if(dft_r1==NULL)
  {
    printf("Fehler beim Speicherallozieren, dft_r1\n");
  }
  else
  {
    printf("dft_r1 Speicher alloziert\n");
  }

  // Speicher allozieren
  dft_i1=(double*)calloc(4*me_byte,sizeof(double)); //4 fach weil bei fft 2erPotenz.....
  if(dft_i1==NULL)
  {
    printf("Fehler beim Speicherallozieren, dft_i1\n");
  }
  else
  {
    printf("dft_i1 Speicher alloziert\n");
  }

  // Speicher allozieren
  res_dft_r=(double*)calloc(4*me_byte,sizeof(double)); //4 fach weil bei fft 2erPotenz.....
  if(res_dft_r==NULL)
  {
    printf("Fehler beim Speicherallozieren, res_dft_r\n");
  }
  else
  {
    printf("res_dft_r Speicher alloziert\n");
  }

  // Speicher allozieren
  res_dft_i=(double*)calloc(4*me_byte,sizeof(double)); //4 fach weil bei fft 2erPotenz.....
  if(res_dft_i==NULL)
  {
    printf("Fehler beim Speicherallozieren, res_dft_i\n");
  }
  else
  {
    printf("res_dft_i Speicher alloziert\n");
  }

  // Speicher allozieren
  inf_dft_r=(double*)calloc(4*me_byte,sizeof(double)); //4 fach weil bei fft 2erPotenz.....
  if(inf_dft_r==NULL)
  {
    printf("Fehler beim Speicherallozieren, inf_dft_r\n");
  }
  else
  {
    printf("inf_dft_r Speicher alloziert\n");
  }

  // Speicher allozieren
  inf_dft_r=(double*)calloc(4*me_byte,sizeof(double)); //4 fach weil bei fft 2erPotenz.....
  if(inf_dft_r==NULL)
  {
    printf("Fehler beim Speicherallozieren, inf_dft_r\n");
  }
  else
  {
    printf("inf_dft_r Speicher alloziert\n");
  }

  // Speicher allozieren
  inf_dft_i=(double*)calloc(4*me_byte,sizeof(double)); //4 fach weil bei fft 2erPotenz.....
  if(inf_dft_i==NULL)
  {
    printf("Fehler beim Speicherallozieren, inf_dft_i\n");
  }
  else
  {
    printf("inf_dft_i Speicher alloziert\n");
  }

  // Speicher allozieren
  res_polynom=(double*)calloc(4*me_byte,sizeof(double)); //4 fach weil bei fft 2erPotenz.....
  if(res_polynom==NULL)
  {
    printf("Fehler beim Speicherallozieren, res_polynom\n");
  }
  else
  {
    printf("res_polynom Speicher alloziert\n");
  }

  printf("\n\n");

/*
int test[100];
int it1;

test[0]=5;
test[1]=7;
test[2]=11;
test[3]=13;
test[4]=17;
test[5]=19;
test[6]=23;
test[7]=29;
test[8]=31;
test[9]=37;
test[10]=41;
test[11]=43;
test[12]=47;
test[13]=53;
test[14]=59;
test[15]=61;
test[16]=67;
test[17]=71;
test[18]=73;
test[19]=79;
test[20]=83;
test[21]=89;
test[22]=97;
test[23]=101;
test[24]=103;
test[25]=107;
test[26]=109;
test[27]=113;
test[28]=127;
test[29]=131;
test[30]=3;

for(it1=0;it1<31;it1++)
{
me_number=test[it1];
*/

  // Beginn Lehmer Test
  u2_len_long=1;
  u2[0]=4;

  for(i1=0;i1<me_number-2;i1++)
  {
printf("Schritt %d:\n",i1);
printf("start get_n()\n");
    n1=get_n(u2_len_long);
printf("start get_einheitswurzel()\n");
    get_einheitswurzel(n1,wr,wi);
printf("start get_fast_dft_vektor()\n");
    get_fast_dft_vektor_2y16(n1,buffer,u2,u2_len_long,wr,wi,dft_r1,dft_i1);
printf("start mul_dft()\n");
    mul_dft(n1,dft_r1,dft_i1,dft_r1,dft_i1,res_dft_r,res_dft_i);
printf("start inverse_dft_vektor()\n");
    get_fast_inverse_dft_vektor(n1,buffer2,wr,wi,res_dft_r,res_dft_i,res_polynom);
    //inverse_dft_vektor(n1,wr,wi,res_dft_r,res_dft_i,inf_dft_r,inf_dft_i,res_polynom);
printf("start decode_polynom_2y16()\n");
    decode_polynom_2y16(res_polynom,n1,u2,&u2_len_long);
//printf("uQuardrat");
//type_long_array_dez(u2,u2_len_long);
printf("start str_minus_zwei()\n");
    str_minus_zwei(u2,&u2_len_long);

//type_long_array(u2,u2_len_long);
//type_long_array_dez(u2,u2_len_long);

printf("start fast_modulo_2y16()\n");
    fast_modulo_2y16(u1,u2,&u1_len_long,&u2_len_long,me_number);

//type_long_array(u2,u2_len_long);
//type_long_array_dez(u2,u2_len_long);
printf("\n");
  }

//type_long_array(u2,u2_len_long);
type_long_array_dez(u2,u2_len_long);

  // effektive lnge vom Array u2 ermitteln
  for(i1=u2_len_long-1;i1>0;i1--)
  {
    if(u2[i1]==0)
    {
       u2_len_long--;
    }
    else
    {
      break;
    }
  }
 
  
  if((u2_len_long==1)&&(u2[0]==0))
  {
    printf("me (2y%d)-1 is prime\n",me_number);
  }
  else
  {
    printf("me (2y%d)-1 is not prime\n",me_number);
  }

//}


  return(0);
}


void type_long_array
/******************/
(
  unsigned long *a1,
  int len_a1
)
/*
Alle Bits des bergebenen long Array werden auf dem Bildschirm mit 0 und 1 dargestellt
*/
{
  int i1;
  int i2;
  unsigned int bit;

  printf("\n");
  for(i1=len_a1-1;i1>=0;i1--)
  {
    for(i2=0;i2<LONG;i2++)
    {
      bit=a1[i1]>>(LONG-1-i2);
      bit<<=(LONG-1);
      bit>>=(LONG-1);
      printf("%u",bit);
    }
    printf(" ");
  }
  printf("\n");
}


void type_long_array_dez
/**********************/
(
  unsigned long *a1,
  int len_a1
)
/*
Alle Longwerte des bergebenen long Arrays werden auf dem Bildschirm ausgegeben.
*/
{
  int i1;

  printf("\n");
  for(i1=len_a1-1;i1>=0;i1--)
  {
    printf("[%d]=%lu   ",i1,a1[i1]);
  }
  printf("\n");
}


void fast_modulo_2y16
/*******************/
(
  unsigned long *u1,
  unsigned long *u2,
  int *u1_anz_long,
  int *u2_anz_long,
  int me_anz_bit
)
/*
  Beschreibung:
  Gegenber der 32 Bit Version ist hier dazu gekommen, dass ein Longwert nicht gefllt wird, sondern
  bereits nach 16Bit der Nchste Longwert abgefllt wird. Das verkompliziert die Sache noch zustzlich.

  Achtung! Die Funktion arbeitet ausschliesslich nur richtig wenn me_anz_bit eine Mersennesche Zahl ist.
  Das heisst bei (2yn)-1 ist me_anz_bit=n. Desweitern darf u2[] nur die max.Grsse haben von (2yn)-1Quadrat.
  Schnelle Modulofunktion fr mersennesche Werte der Form 2yn-1.
  Einige Gedanken:
  res_2y16_len hat immer eine laenge von 2yn zBsp.:2,4,8,16,32,...usw. das ergibt sich aus
  der FastFourierTransfromation. Eine Polynommultiplikation mit Beispielsweise jeweils 5 Vektoren
  ergeben mit der fft ein Ergebnispolynom der grsse 16 Vektoren. Das Ergebnis hat aber maximal 10
  Vektoren. Das heisst die restlichen 6 Vektoren sind immer 0.
  Wichtig!
  mersenne_number ist ja auch die Anzahl bits dieser Zahl zur Basis 2.
  u_2y16 entsteht ja durch eine Multiplikation mit sich selber vom jeweiligen Rest der Division 
  mit Divisor mersenne_number. Daraus folgt:
  u_2y16_len_bit kann maximal doppelt so gross (lang) sein wie mersenne_number.


  Beispiel: u2 modulo me 38  (me msste natrlich eine Primzahl sein, aber frs Beispiel gehts trotzdem)

  Ausgangslage:
                       [4]      [3]      [2]      [1]      [0]     
                      ------------------------------------------
                      111111 11111111 11111111 11111111 11111111  me[]   me_anz_bit 38
                      ------------------------------------------         me_anz_byte=me_anz_bit/8+1=5
                                                                         me_anz_rest_bit=me_anz_bit%8=6
  87654321 87654321 87654321 87654321 87654321 87654321 87654321
     [6]      [5]      [4]      [3]      [2]      [1]      [0]     
  -------------------------------------------------------------- 
  01001100 10110101 11010011 10101001 00101011 10101010 10010101  u2[]   u2_anz_bit 56   u2_anz_byte 7
  ====================------------------------------------------

  Ergebnis:
                    87654321 87654321 87654321 87654321 87654321 
                       [4]      [3]      [2]      [1]      [0]     
                      ------------------------------------------ 
  a[]                 010011 10101001 00101011 10101010 10010101  u2[]
                      ------------------------------------------
                                      -------------------------- 
  b[]                                 00000001 00110010 11010111  b[]
                                      --------------------------
                    --------------------------------------------
  c[]               00010011 10101001 00101100 11011101 01101100  u1[]   u1_anz_byte 5
                    --------------------------------------------

  Anstatt ein neues Array a[] wird das array u2 bernommen.

  Daten fr das Beispiel:
  mersenne_number=38;
  u2[0]=2838211221;
  u2[1]=5027283;
  u2_len_long=2;
  */
{
  int i1;
  int i2;
  int shift1;
  int shift2;
  int tmp2;
  int me_anz_long;
  int me_anz_rest_bit;
  __int64 tmp_i64;
  unsigned long last_byte_me;
  unsigned long tmp1;
  unsigned long tmp3;


  // effektive lnge vom Array u2 ermitteln
  for(i1=(*u2_anz_long)-1;i1>0;i1--)
  {
    if(u2[i1]==0)
    {
       (*u2_anz_long)--;
    }
    else
    {
      break;
    }
  }

  me_anz_long=me_anz_bit/BIT_PER_LONG +1;

  // um Zeit zu sparen kurz genau abklren ob u2[] wirklich grsser ist als me
  if((*u2_anz_long)<me_anz_long)
  {
    return; // u2 ist bereits der Rest da es kleiner ist als me
  }

  me_anz_rest_bit=me_anz_bit%BIT_PER_LONG;

  // letztes Byte von me generieren
  last_byte_me=MAX_LONG_WERT;
  last_byte_me>>=BIT_PER_LONG-me_anz_rest_bit;

  if(me_anz_rest_bit==0)
  {
    //me_anz_long--;
    // Das darf bei me Zahlen nie eintreffen!!
    printf("Die Me-Zahl ist durch %d teilbar ??? Unbehandelter Fehler aus fast_mersenne_modulo", BIT_PER_LONG);
  }
 
  // genau abklren ob u2 wirklich grsser ist als me
  tmp2=*u2_anz_long;

  if(tmp2==me_anz_long)
  {
    // bitweise abklren
    if(u2[tmp2-1]<=last_byte_me)
    {
      return; // me ist grsser als u2
      // Wenn beide hchstwertigen Bytes gleich gross sind dann muss me grsser sein weil me aus 
      // nur Einsen besteht und es keine Quadratzahl gibt die das erfllen kann.
    }
    // else u2 ist gsser oder gleich wie me, also ganz normal weitermachen
  }

  //Das Grenzbyte fr u2 wie auch fr u1 extrahieren
  tmp1=u2[me_anz_long-1];

  //Das Array u1[] abfllen
  shift1=me_anz_rest_bit; // Bereich 0...LONG-1
  //shift2=BIT_PER_LONG-me_anz_rest_bit+MANCO_TO_LONG32; // Bereich LONG...MANCO_TO_LONG+1 
  shift2=LONG-me_anz_rest_bit; // Bereich LONG...MANCO_TO_LONG+1 

  i2=0;
  for(i1=me_anz_long-1;i1<(*u2_anz_long)-1;i1++)
  {
    tmp3=u2[i1+1];
    tmp3<<=(LONG-me_anz_rest_bit);
    //tmp3>>=(LONG-me_anz_rest_bit);
    //tmp3<<=(BIT_PER_LONG-me_anz_rest_bit);
    //tmp3>>=LONG-me_anz_rest_bit-(BIT_PER_LONG-me_anz_rest_bit);
    // obige 3 Zeilen sind gekrzt die folgende Zeile:
    //tmp3>>=LONG-BIT_PER_LONG;
    tmp3>>=MANCO_TO_LONG32;
    u1[i2]=(u2[i1]>>shift1)+tmp3;
    i2++;
  }
  //letzten Long von u1[] noch eintragen
  *u1_anz_long=i2;
  u1[i2]=u2[(*u2_anz_long)-1]>>shift1;
  if(u1[i2])(*u1_anz_long)++;

  //u1[] ist fertig abgefllt. Nun die Lnge von u2[] korrigieren
  *u2_anz_long=me_anz_long;

  //Zum Schluss noch das Grenzbyte fr u2 neu berechnen
  tmp1<<=shift2;
  tmp1>>=shift2;
  u2[(*u2_anz_long)-1]=tmp1;

  //das Array u2[] und u1[] addieren und in u2[] eintragen
  tmp1=0;
  for(i1=0;i1<(*u1_anz_long);i1++)
  {
    tmp_i64=u2[i1]+u1[i1]+tmp1;
    u2[i1]=(unsigned long)tmp_i64;
    u2[i1]<<=MANCO_TO_LONG32;
    u2[i1]>>=MANCO_TO_LONG32;
    if(tmp_i64>u2[i1]) tmp1=1; else tmp1=0;
  }

  for(;i1<(*u2_anz_long);i1++)
  {
    tmp_i64=u2[i1]+tmp1;
    u2[i1]=(unsigned long)tmp_i64;
    u2[i1]<<=MANCO_TO_LONG32;
    u2[i1]>>=MANCO_TO_LONG32;
    if(tmp_i64>u2[i1])
    {
      tmp1=1;
    }
    else
    {
      tmp1=0;
      break;
    }
  }

  if(tmp1==1)
  {
    u2[*u2_anz_long]=1;
    *u2_anz_long++;
  }

  // Es knnte nun noch sein, dass u2[] fhrende Longwerte der Grsse 0 hat. Diese eliminieren
  for(i1=(*u2_anz_long)-1;i1>0;i1--)
  {
    if(u2[i1])
    {
      break;
    }
    else
    {
      (*u2_anz_long)--;
    }
  }

  if((*u2_anz_long)==me_anz_long && u2[(*u2_anz_long)-1]==last_byte_me)
  {
    // in diesem Fall ist der Rest gleich oder kleiner me
    for(i1=0;i1<(*u2_anz_long)-2;i1++)
    {
      if(u2[i1]<MAX_LONG_WERT)
      {
        // der Rest ist kleiner als me
        return;
      }
    }
    // in diesem Fall ist der berechnete Rest gleich me
    *u2_anz_long=1;
    u2[0]=0;
    return;
  }
  else if((*u2_anz_long)>me_anz_long || ((*u2_anz_long)==me_anz_long && u2[(*u2_anz_long)-1]>=last_byte_me))
  {
    // in diesem Fall ist der berechnete Rest grsser wie me, jedoch noch maximal 0.5 mal.
    // das heisst, ich kann folgendes machen: Das hchstwertige Bit von u2[] von 1 auf 0
    // setzen und zur Summe von u2[] 1 addieren.

    // hchstwertiges 1er Bit von u2[] auf 0 setzen
    tmp1=BIGEST_LONG_BIT;
    tmp2=(*u2_anz_long)-1;
  
    while(tmp1>u2[tmp2])
    {
      tmp1/=2;
    }
    u2[tmp2]-=tmp1;

    // Das Addieren von 1 ist dummerweise aufwendig um alle Flle abzudecken......
    for(i1=0;i1<(*u2_anz_long);i1++)
    {
      if(u2[i1]<MAX_LONG_WERT)
      {
        u2[i1]++;
        break;
      }
      else
      {
        u2[i1]=0; // (u2[i1]==MAX_LONG_WERT) es gibt einen bertrag, also weitermachen...

        if(i1==((*u2_anz_long)-1))
        {
          u2[*u2_anz_long]=1;
          *u2_anz_long++;
          break; // eingentlich ueberflssiges break, da das sowieso der letzte Schlaufendurchlauf ist.
        }
      }
    }
  }
}


void str_minus_zwei
/******************/
(
  unsigned long *u1,
  int *u1_len_long
)
/*
  Beschreibung:
  Von der Stringzahl u1[] wird 2 subtrahiert. u1_anz_long wird gegebenenfalls angepasst.
  Zu beachten! Ein String mit der laenge u1_anz_long >1 muss auch wirklich einen Inhalt haben.
*/
{
  // Hufigster Fall:
  if(u1[0]>1)
  {
    u1[0]-=2;
    return;
  }

  int i1;

  if((*u1_len_long)<=1)
  {
    printf("Vom String u1[] kann nicht 2 subtrahiert werden! Nicht behandelter Fehler aus str_minus_zwei");
    return;
  }

  if(u1[0]==1) u1[0]=MAX_LONG_WERT;
  else if(u1[0]==0) u1[0]=MAX_LONG_WERT-1;

  for(i1=1;i1<(*u1_len_long);i1++)
  {
    if(u1[i1]==0)
    {
      u1[i1]=MAX_LONG_WERT;
    }
    else
    {
      u1[i1]--;
      if(u1[i1]==0)(*u1_len_long)--;
      return;
    }
  }
}


int get_n
/*******/
(
  int u2_len_long
)
/*
  Beschreibung:
  Es wird n zurckgegeben fr die FFT d.h. die nchste 2erPotenz von u2_len_long *2
*/
{
  int i1=1;

  while(i1<u2_len_long)
  {
    i1*=2;
  }
  return(2*i1);
}


void get_einheitswurzel
/*********************/
(
  int n,
  double *wr,
  double *wi
)
/*
  Beschreibung:
  Es werden alle n Einheitswurzeln berechnet und in wr und wi eingetragen.
  In wr steht der Realanteil, in wi der Imaginaeranteil.
*/
{
  int i1;
  double delta_phi;
  double phi;

  delta_phi=6.2831853071795862/n; //2.0*3.141592653589793/n;
  phi=0;

  for(i1=0;i1<n;i1++)
  {
    wr[i1]=cos(phi);
    wi[i1]=sin(phi);
    phi+=delta_phi;
  }
}


void get_einheitswurzel2
/**********************/
(
  int n,
  double *wr,
  double *wi
)
/*
  Beschreibung:
  Es werden alle n Einheitswurzeln berechnet und in wr und wi eingetragen.
  In wr steht der Realanteil, in wi der Imaginaeranteil.
*/
{
  int i1;
  double phi;

  for(i1=0;i1<n;i1++)
  {
    phi=(6.2831853071795862*i1)/n;
    wr[i1]=cos(phi);
    wi[i1]=sin(phi);
  }
}


void get_fast_dft_vektor_2y16
/***************************/
(
  int n,
  unsigned long *buffer,
  unsigned long *numerals,
  int len_numerals,
  double *wr,
  double *wi,
  double *dft_r,
  double *dft_i
)
/*
  Beschreibung:
  Es werden dft_r und dft_i berechnet mit der Fast Fourier Transformation.
  Alle anderen uebergabeparameter sind bei aufruf dieser Funktion bereits abgefuellt.
  In dft_r steht der Realanteil, in dft_i der Imaginaeranteil.
*/
{
  int i1;
  int i2;
  int i3;
  int i4;
  int i5;
  int dw;
  int half_n;
  double dft_r_tmp1;
  double res_dft_r;
  double res_dft_i;
  double dft_i_tmp1;

  void mul_one_dft(double dft_r1,double dft_i1,double dft_r2,double dft_i2,double*res_dft_r,double*res_dft_i);
  void inputvektor1_2y16(unsigned long *numerals,unsigned long *buffer,int n);

  half_n=n/2;

  for(i1=0;i1<n;i1++)
  {
    dft_i[i1]=0.0;
  }

  // n fr die fft kann grsser sein als len_numerals vom Vektor,deshalb die freien Pltze Null setzen.
  for(i1=len_numerals;i1<half_n;i1++)
  {
    numerals[i1]=0;
  }

  inputvektor1_2y16(numerals,buffer,half_n);

  // Jede Ziffer zweimal eintragen.
  i2=0;
  for(i1=0;i1<n;i1++)
  {
    dft_r[i2]  =numerals[i1];
    dft_r[i2+1]=numerals[i1];
    i2+=2;
  }

  dw=n/4; // bei a 64 ist dw:16,8,4,2,1
  i4=1; // bei a 64 ist dw:1,2,4,8,16 pro Sequenz die Anzahl2erOmegaBloecke
  i5=2; // 2,4,8,16,...

  for(i1=4;i1<=n;i1*=2) //i1=4,8,16,32,64,...
  {
    for(i3=0;i3<dw;i3++) // Anzahl Omega 2er Bloecke
    {
      
      for(i2=0;i2<i5;i2++) // Anzahl Omega
      {
         dft_r_tmp1=dft_r[i2+i3*i1];
         dft_i_tmp1=dft_i[i2+i3*i1];

         mul_one_dft(wr[i2*dw],wi[i2*dw],dft_r[i2+i3*i1+i5],dft_i[i2+i3*i1+i5],&res_dft_r,&res_dft_i);
 
         dft_r[i2+i3*i1]+=res_dft_r;
         dft_i[i2+i3*i1]+=res_dft_i;

         dft_r[i2+i3*i1+i5]=dft_r_tmp1-res_dft_r;
         dft_i[i2+i3*i1+i5]=dft_i_tmp1-res_dft_i;
      }

    }
    dw/=2;
    i5*=2;
  }
}


void get_fast_inverse_dft_vektor
/******************************/
(
  int n,
  double *buffer,
  double *wr,
  double *wi,
  double *dft_r,
  double *dft_i,
  double *res_polynom
)
/*
  Beschreibung:
  Es werden dft_r und dft_i berechnet mit der Fast Fourier Transformation.
  Alle anderen uebergabeparameter sind bei aufruf dieser Funktion bereits abgefuellt.
  In dft_r steht der Realanteil, in dft_i der Imaginaeranteil.
*/
{
  int i1;
  int i2;
  int i3;
  int i4;
  int i5;
  int dw;
  double dft_r_tmp1;
  double res_dft_r;
  double res_dft_i;
  double dft_i_tmp1;
  double dft_tmp;

  void mul_one_dft(double dft_r1,double dft_i1,double dft_r2,double dft_i2,double*res_dft_r,double*res_dft_i);
  void inputvektor2(double *dft_r,double *buffer,int n);

  inputvektor2(dft_r,buffer,n);
  inputvektor2(dft_i,buffer,n);

  // Bereitstellen eine Stufe nach dem Generieren des Inputvektors
  for(i1=0;i1<n;i1+=2)
  {
    dft_tmp=dft_r[i1];
    dft_r[i1]+=dft_r[i1+1];
    dft_r[i1+1]=dft_tmp-dft_r[i1+1];

    dft_tmp=dft_i[i1];
    dft_i[i1]+=dft_i[i1+1];
    dft_i[i1+1]=dft_tmp-dft_i[i1+1];
  }
  
  dw=n/4; // bei a 64 ist dw:16,8,4,2,1
  i4=1; // bei a 64 ist dw:1,2,4,8,16 pro Sequenz die Anzahl2erOmegaBloecke
  i5=2; // 2,4,8,16,...

  for(i1=4;i1<=n;i1*=2) //i1=4,8,16,32,64,...
  {
    for(i3=0;i3<dw;i3++) // Anzahl Omega 2er Bloecke
    {
      
      for(i2=0;i2<i5;i2++) // Anzahl Omega
      {
         dft_r_tmp1=dft_r[i2+i3*i1];
         dft_i_tmp1=dft_i[i2+i3*i1];

         mul_one_dft(wr[i2*dw],(-1*wi[i2*dw]),dft_r[i2+i3*i1+i5],dft_i[i2+i3*i1+i5],&res_dft_r,&res_dft_i);
         
         dft_r[i2+i3*i1]+=res_dft_r;
         dft_i[i2+i3*i1]+=res_dft_i;

         dft_r[i2+i3*i1+i5]=dft_r_tmp1-res_dft_r;
         dft_i[i2+i3*i1+i5]=dft_i_tmp1-res_dft_i;
      }

    }
    dw/=2;
    i5*=2;
  }
  for(i1=0;i1<n;i1++)
  {
    res_polynom[i1]=(dft_r[i1]+dft_i[i1])/n;
  }
}


void mul_dft
/**********/
(
  int n,
  double *dft_r1,
  double *dft_i1,
  double *dft_r2,
  double *dft_i2,
  double *res_dft_r,
  double *res_dft_i
)
/*
  Beschreibung:
  Es werden dft_r1 und dft_i1 multipliziert mit dft_r2 und dft_i2.
  Alle dft sind Arrays der groesse n. Jeder dft Arrayplatz ist eine komplexe Zahl.
  Es werden also n mal komplexe Zahlen multipliziert und in res_dft_r,res_dft_i eingetragen.
  _r steht fuer Realanteil, _i steht fuer Imaginaeranteil.
*/
{
  int i1;
  
  // fuer die Multiplikation von komplexen Zahlen gilt: (a,b)*(c,d)=(a*c-b*d,a*d+b*c)
  for(i1=0;i1<n;i1++)
  {
    res_dft_r[i1]=(dft_r1[i1]*dft_r2[i1])-(dft_i1[i1]*dft_i2[i1]);
    res_dft_i[i1]=(dft_r1[i1]*dft_i2[i1])+(dft_i1[i1]*dft_r2[i1]);
  }
}


void mul_one_dft
/**************/
(
  double dft_r1,
  double dft_i1,
  double dft_r2,
  double dft_i2,
  double *res_dft_r,
  double *res_dft_i
)
/*
  Beschreibung:
  Es werden zwei komplexe Zahlen multipiliziert.
  Es werden dft_r1 und dft_i1 multipliziert mit dft_r2 und dft_i2
  und in res_dft_r,res_dft_i eingetragen.
  _r steht fuer Realanteil, _i steht fuer Imaginaeranteil.
*/
{
  // fuer die Multiplikation von komplexen Zahlen gilt: (a,b)*(c,d)=(a*c-b*d,a*d+b*c)
  *res_dft_r=(dft_r1*dft_r2)-(dft_i1*dft_i2);
  *res_dft_i=(dft_r1*dft_i2)+(dft_i1*dft_r2);
}


void inverse_dft_vektor
/*********************/
(
  int n,
  double *wr,
  double *wi,
  double *dft_r,
  double *dft_i,
  double *inf_dft_r,
  double *inf_dft_i,
  double *res_polynom
)
/*
  Beschreibung:
  Es werden aus dft_r und dft_i das Ergebnis berechnet. Das Ergebnis wird in inf_dft_r
  und inf_dft_i eingetragen.
  Alle anderen uebergabeparameter sind bei aufruf dieser Funktion bereits abgefuellt.
  _r steht fuer Realanteil, _i fuer Imaginaeranteil.
*/
{
  int i1;
  int i2;
  int i3;
  int i4;
  
  for(i1=0;i1<n;i1++)
  {
    inf_dft_r[i1]=0.0;
    inf_dft_i[i1]=0.0;
  }

  for(i2=0;i2<n;i2++)
  {
    inf_dft_r[0]+=dft_r[i2]; // *1 weil der r-Anteil immer 1 ist.
    //inf_dft_i[0]+=dft_i[i2]*0;  weglassen weil der i-Anteil immer 0 ist.
  }

  i3=1;
  for(i1=1;i1<n;i1++)
  {
    for(i2=0;i2<n;i2++)
    {
      i4=(i2*i3)%n;
      inf_dft_r[i1]+=dft_r[i2]*(wr[i4]);
      inf_dft_i[i1]+=dft_i[i2]*(wi[i4]);
    }
    i3++;
  }

  for(i1=0;i1<n;i1++)
  {
    res_polynom[i1]=(inf_dft_r[i1]+inf_dft_i[i1])/n;
  }
/*
  for(i1=0;i1<n;i1++)
  {
    inf_dft_r[i1]/=n;
    inf_dft_i[i1]/=n;
  }
*/
}


void inputvektor2
/***************/
(
  double *numerals,
  double *buffer,
  int n
)
/*
  Beschreibung:
  Rekursive Funktion zur bereitstellung des Inputvektors fuer die fft.
  In numerals[0] steht die niederwertigste Ziffer.
*/
{
  int i1;
  int i2=0;

  for(i1=0;i1<n;i1+=2)
  {
    buffer[i2]=numerals[i1];
    i2++;
  }

  for(i1=1;i1<n;i1+=2)
  {
    buffer[i2]=numerals[i1];
    i2++;
  }

  for(i1=0;i1<n;i1++)
  {
    numerals[i1]=buffer[i1];
  }

  if(n<=4)return;

  inputvektor2(&numerals[0],&buffer[0],n/2);
  inputvektor2(&numerals[n/2],&buffer[n/2],n/2);
}


void inputvektor1_2y16
/********************/
(
  unsigned long *numerals,
  unsigned long *buffer,
  int n
)
/*
  Beschreibung:
  Rekursive Funktion zur bereitstellung des Inputvektors fuer die fft.
  In numerals[0] steht die niederwertigste Ziffer.
*/
{
  int i1;
  int i2=0;

  for(i1=0;i1<n;i1+=2)
  {
    buffer[i2]=numerals[i1];
    i2++;
  }

  for(i1=1;i1<n;i1+=2)
  {
    buffer[i2]=numerals[i1];
    i2++;
  }

  for(i1=0;i1<n;i1++)
  {
    numerals[i1]=buffer[i1];
  }

  if(n<=4)return;

  inputvektor1_2y16(&numerals[0],&buffer[0],n/2);
  inputvektor1_2y16(&numerals[n/2],&buffer[n/2],n/2);
}


void decode_polynom_2y16
/**********************/
(
  double *polynom,
  int polynom_len,
  unsigned long *res_2y16,
  int *res_2y16_len
)
/*
  Beschreibung:
  Ein Polynom wird in eine Zahl der Basis 2y16 berfhrt.
  Die uebergebenen Polynom-Werte mssen nicht gerundet sein.
  polynom ist ein Array der grsse polynom_len von double Werten.
  Das Ziel dieser Funktion ist es ein Polynom der Basis 2y10 als eine Zahl in der Basis 2y16
  umzuwandeln. Die Einzelnen Vektoren des Polynoms werden zuerst gerundet, dann wird berechnet
  ob ein ebertrag stattfindet etc...
  In polynom[0] steht die niederwertigste Ziffer.
  In res_2y16[0] steht die niederwertigste Ziffer.
  Die neue Zahl wird in das Array res_2y16 eingetragen.
  Das Array polynom wird nicht verndert.
  In res_2y16_len steht die Anzahl Stellen der Zahl.
*/
{
  __int64  temp_i;
  double tmp_f1;
  double polynom_tmp_f2;

  int i1;
  __int64 tmp1=0;
  __int64 polynom_tmp;

  for(i1=0;i1<polynom_len;i1++)
  {
    polynom_tmp_f2=polynom[i1];
    temp_i=(__int64)polynom_tmp_f2;
    tmp_f1=polynom_tmp_f2-temp_i;

    if(polynom_tmp_f2>0.0)
    {
      if (tmp_f1<0.5)
      { 
        /* abrunden */
        polynom_tmp_f2=(double)temp_i;
      }
      else
      {
        /* aufrunden */
        polynom_tmp_f2=(double)temp_i+1;
      }
    }
    else
    {
      // folgendes sollte eigentlich nie eintreffen... da nur positive Vektoren der Eingangspolynome ..
      if (tmp_f1>(-0.5)) // >-0.5 ist bsp. -0.4999
      { 
        /* abrunden */
        polynom_tmp_f2=(double)temp_i;
      }
      else
      {
        /* aufrunden */
        polynom_tmp_f2=(double)temp_i-1;
      }
    }

    polynom_tmp=(__int64)polynom_tmp_f2+tmp1;
    if(polynom_tmp>MAX_LONG_WERT)
    {
      tmp1=polynom_tmp/(__int64)NY_X;
      polynom_tmp%=(__int64)NY_X;
      res_2y16[i1]=(unsigned long)polynom_tmp;
    }
    else if(polynom_tmp<0)
    {
      tmp1=(polynom_tmp/(__int64)NY_X)-1;
      polynom_tmp=tmp1*(-(__int64)NY_X)+polynom_tmp;
      res_2y16[i1]=(unsigned long)polynom_tmp;
    }
    else
    {
      tmp1=0;
      res_2y16[i1]=(unsigned long)polynom_tmp;
    }
  }

  *res_2y16_len=polynom_len;

  if(tmp1)
  {
    res_2y16[i1]=(unsigned long)tmp1;
    *res_2y16_len=polynom_len++;
  }
}
